## unity 7.5.1+22.04.20211026.2-0ubuntu1

=== CMakeLists.txt ===
project (unity)
cmake_minimum_required(VERSION 2.8.9)

include (cmake/Documentation.cmake)
include (cmake/pch.cmake)
include (GNUInstallDirs)

#
# Base bits
#
set (PROJECT_NAME "unity")
set (UNITY_MAJOR 7)
set (UNITY_MINOR 5)
set (UNITY_MICRO 1)
set (UNITY_VERSION "${UNITY_MAJOR}.${UNITY_MINOR}.${UNITY_MICRO}")
set (UNITY_API_VERSION "6.0")
set (UNITY_COMPONENTS_VERSION "6")

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DGNOME_DESKTOP_USE_UNSTABLE_API -std=c++11 -fno-permissive")
set (CMAKE_CXX_FLAGS_DEBUG "-g3 -DUNITY_DEBUG_BUILD")
set (CMAKE_CXX_FLAGS_RELEASE "")

option(
  ENABLE_X_SUPPORT
  "Enable X.org support in unity"
  ON
)

option(
  ENABLE_UNIT_TESTS
  "Enable Unity Unit Tests"
  ON
)

# This is due to bug lp:668799 - qemu-arm segfaults executing msgmerge
option(
  I18N_SUPPORT
  "Enable I18N, do the .po file thing."
  ON
)

option(
  ENABLE_NETWORKAREAREGION_PLUGIN
  "Enable Unity Network Area region Plugin"
  OFF
)

if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "x86_64" OR ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "armv7l" OR ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64")
  set (PIC_FLAGS "-fPIC")
endif()

if (ENABLE_X_SUPPORT)
  add_definitions(-DUSE_X11)
  message("Unity is configured with support for X.org")
else ()
  message("Unity is configured with without X.org")
  add_definitions(-DNO_X11)
endif ()

if (BUILD_GLES)
  add_definitions(-DNUX_OPENGLES_20)
  add_definitions(-DUSE_GLES)
  set (UNITY_STANDALONE_LADD "unity-core-${UNITY_API_VERSION};m;pthread;dl")
else ()
  set (UNITY_STANDALONE_LADD "unity-core-${UNITY_API_VERSION};m;pthread;dl;GL;GLU")
endif ()

if (CMAKE_BUILD_TYPE MATCHES coverage)
  set (COVERAGE_XML_FILE "${CMAKE_BINARY_DIR}/coverage.xml")
# FIXME: Read below
#  set (COVERAGE_INFO_FILE "${CMAKE_BINARY_DIR}/coverage-html.info")
#  set (COVERAGE_HTML_DIR "${CMAKE_BINARY_DIR}/coverage-html")

  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage" )
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage" )
  set (CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage" )
  set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage" )

  find_program(GCOVR_EXECUTABLE gcovr HINTS ${GCOVR_ROOT} "${GCOVR_ROOT}/bin")
  if (NOT GCOVR_EXECUTABLE)
      message(FATAL_ERROR "Cannot enable coverage targets because gcovr was not found.")
  else ()
      message (STATUS "Enabling XML coverage report")
      add_custom_target (coverage-xml
          COMMAND  "${GCOVR_EXECUTABLE}" --exclude="tests.*" --exclude="obj-.*" -x -r "${CMAKE_SOURCE_DIR}" -o "${COVERAGE_XML_FILE}")
  endif()

# FIXME: This got commented out, as it forces a strict dependency on lcov
#  find_program(LCOV_EXECUTABLE lcov HINTS ${LCOV_ROOT} "${LCOV_ROOT}/bin")
#  find_program(GENHTML_EXECUTABLE genhtml HINTS ${GENHTML_ROOT} "${GENHTML_ROOT}/bin")
#  if (NOT LCOV_EXECUTABLE)
#      message(FATAL_ERROR "Cannot enable coverage targets because gcovr was not found.")
#  elseif (NOT GENHTML_EXECUTABLE)
#      message(FATAL_ERROR "Cannot enable coverage targets because genhtml was not found.")
#  else ()
#      message (STATUS "Enabling HTML coverage report")
#      add_custom_target (coverage-html
#          COMMAND "${LCOV_EXECUTABLE}" --directory "${CMAKE_BINARY_DIR}" --capture --output-file "${COVERAGE_INFO_FILE}"
#          COMMAND "${GENHTML_EXECUTABLE}" --output-directory "${COVERAGE_HTML_DIR}" "${COVERAGE_INFO_FILE}")
#  endif()

endif (CMAKE_BUILD_TYPE MATCHES coverage)


#
# Niceties
#
set (ARCHIVE_NAME unity-${UNITY_VERSION})

add_custom_target (pre-distcheck
  COMMAND echo ""
       && echo "• Releasing Unity ${UNITY_VERSION}"
       && cd ${CMAKE_SOURCE_DIR}
       && echo "• Generating ChangeLog"
       && bzr log --gnu-changelog > ChangeLog
       && echo "• Generating AUTHORS"
       && bzr log --long --levels=0 | grep -e "^\\s*author:" | cut -d ":" -f 2 | sed "s/,/\n/g" | sed -r -f AUTHOR-glue | sort -u | uniq -i > AUTHORS
       && echo "• Running Distcheck"
  )

add_custom_target (dist
  COMMAND echo "• Creating Tarball"
       && bzr export --root=${ARCHIVE_NAME} ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2
       && echo "• Signing Tarball"
       && gpg --armor --sign --detach-sig ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )
add_dependencies(dist pre-distcheck)

add_custom_target (distcheck
  COMMAND cd ${CMAKE_BINARY_DIR}
       && rm -rf ${ARCHIVE_NAME}
       && tar xf ${ARCHIVE_NAME}.tar.bz2
       && mkdir ${ARCHIVE_NAME}/build
       && cd ${ARCHIVE_NAME}/build
       && cmake -DCMAKE_INSTALL_PREFIX=../install -DGSETTINGS_LOCALINSTALL=ON .. -DCMAKE_MODULE_PATH=/usr/share/cmake
       && make
       && make install
       && make check-headless
  )
add_dependencies(distcheck dist)

add_custom_target (post-distcheck
  COMMAND echo "• Committing Release"
       && bzr commit -m\"Release ${UNITY_VERSION}\" --unchanged
       && echo "• Tagging Release"
       && bzr tag ${UNITY_VERSION}
       && echo "• Unity ${UNITY_VERSION} is ready for release."
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )
add_dependencies(post-distcheck distcheck)

add_custom_target (release)
add_dependencies (release distcheck)

#
# config.h
#
set (VERSION "${UNITY_VERSION}")
set (PREFIXPATH "${CMAKE_INSTALL_PREFIX}")
set (UNITY_LIBDIR "${CMAKE_INSTALL_FULL_LIBDIR}/${PROJECT_NAME}")
set (UNITY_DATADIR "${CMAKE_INSTALL_FULL_DATADIR}/${PROJECT_NAME}")
set (UNITY_INSTALL_LIBDIR "${CMAKE_INSTALL_LIBDIR}/${PROJECT_NAME}")
set (PKGDATADIR "${UNITY_DATADIR}/icons")
set (SOURCEDATADIR "${CMAKE_CURRENT_SOURCE_DIR}/resources")
set (BUILDDIR "${CMAKE_BINARY_DIR}")
set (TESTDATADIR "${CMAKE_CURRENT_SOURCE_DIR}/tests/data")
set (LOCALE_DIR "${CMAKE_INSTALL_FULL_LOCALEDIR}")
# specify the domain directly rather than refering to a variable
# like ${PROJECT_NAME} to no confuse dh_translations
set (GETTEXT_PACKAGE "unity")

find_package (PkgConfig)
execute_process (COMMAND ${PKG_CONFIG_EXECUTABLE} gtk+-3.0 --variable prefix OUTPUT_VARIABLE GTK_PREFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process (COMMAND ${PKG_CONFIG_EXECUTABLE} unity --variable lensesdir OUTPUT_VARIABLE LENSES_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process (COMMAND ${PKG_CONFIG_EXECUTABLE} indicator3-0.4 --variable indicatordir OUTPUT_VARIABLE INDICATORDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process (COMMAND ${PKG_CONFIG_EXECUTABLE} indicator3-0.4 --variable iconsdir OUTPUT_VARIABLE INDICATORICONDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process (COMMAND ${PKG_CONFIG_EXECUTABLE} indicator3-0.4 --variable prefix OUTPUT_VARIABLE INDICATORPREFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
set (INDICATOR_SERVICE_DIR "${INDICATORPREFIX}/share/${PROJECT_NAME}/indicators")

configure_file (${CMAKE_SOURCE_DIR}/config.h.cmake ${CMAKE_BINARY_DIR}/config.h)

#
# i18n
#
find_package (Gettext REQUIRED)

set (COMPIZ_I18N_DIR ${CMAKE_SOURCE_DIR}/po)

add_custom_command (OUTPUT ${CMAKE_SOURCE_DIR}/po/${PROJECT_NAME}.pot
		COMMAND xgettext -c --from-code=UTF-8 --files-from ${CMAKE_SOURCE_DIR}/po/POTFILES.in --keyword=_ -o ${CMAKE_SOURCE_DIR}/po/${PROJECT_NAME}.pot --copyright-holder="Canonical Ltd" --msgid-bugs-address="ayatana-dev@lists.launchpad.net" --no-wrap --no-location
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		)

if (I18N_SUPPORT)
if (GETTEXT_FOUND)
        set (HAVE_GETTEXT true)
        file (GLOB _translations ${CMAKE_SOURCE_DIR}/po/*.po)
        GETTEXT_CREATE_TRANSLATIONS (${CMAKE_SOURCE_DIR}/po/${PROJECT_NAME}.pot
                ALL ${_translations})
endif (GETTEXT_FOUND)
endif()

#
# Enable or disable boot logging
#
option (BOOT_LOGGER "Enable startup performance logging" OFF)
if (BOOT_LOGGER)
    SET (BOOT_LOGGER_FLAG "-DENABLE_LOGGER")
endif (BOOT_LOGGER)

SET (MAINTAINER_CXXFLAGS "-Wall -Wcast-align -Wempty-body -Wformat-security -Winit-self -Warray-bounds -Wno-error=deprecated-declarations")

option (DISABLE_ERROR_ON_LOCAL_TYPEDEFS_WARNINGS "Disable errors when local typedefs are unused" ON)
if (DISABLE_ERROR_ON_LOCAL_TYPEDEFS_WARNINGS)
  SET (MAINTAINER_CXXFLAGS "${MAINTAINER_CXXFLAGS} -Wno-error=unused-local-typedefs")
endif (DISABLE_ERROR_ON_LOCAL_TYPEDEFS_WARNINGS)

option (DISABLE_MAINTAINER_CXXFLAGS "Disable maintainer CXXFlags" OFF)
if (DISABLE_MAINTAINER_CXXFLAGS)
  SET (MAINTAINER_CXXFLAGS "")
endif (DISABLE_MAINTAINER_CXXFLAGS)

# Make sure these flags are used for every build.
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${MAINTAINER_CXXFLAGS}")

#
# Compiz Plugins
#
set(UNITY_PROTOCOL_PRIVATE_DEPS unity-protocol-private>=7.1.0)
set(UNITY_PLUGIN_SHARED_DEPS
    ${UNITY_PROTOCOL_PRIVATE_DEPS}
    appstream-glib
    atk
    atk-bridge-2.0
    cairo>=1.13.1
    dbusmenu-glib-0.4
    dee-1.0
    gio-2.0>=2.30.0
    gio-unix-2.0
    gmodule-2.0
    gthread-2.0
    gtk+-3.0>=3.1
    indicator3-0.4>=0.4.90
    json-glib-1.0
    libbamf3>=0.5.3
    gnome-desktop-3.0
    libunity-settings-daemon
    libnotify
    libstartup-notification-1.0
    nux-4.0>=4.0.5
    sigc++-2.0>=2.4.0
    unity-misc>=0.4.0
    xpathselect=1.4
    zeitgeist-2.0
)

set(UNITY_PLUGIN_DEPS ${UNITY_PLUGIN_SHARED_DEPS})

if(ENABLE_X_SUPPORT)
  set(UNITY_PLUGIN_DEPS
      ${UNITY_PLUGIN_DEPS}
      compiz>=0.9.11
      libgeis
      x11
      xfixes
      xi>=1.6.99.1
      xrender>=0.9
  )
endif ()

pkg_check_modules (CACHED_UNITY_DEPS REQUIRED ${UNITY_PLUGIN_DEPS})
pkg_check_modules (CACHED_UNITY_PRIVATE_DEPS REQUIRED ${UNITY_PROTOCOL_PRIVATE_DEPS})
find_library (UNITY_PROTOCOL_PRIVATE_LIB unity-protocol-private ${CACHED_UNITY_PRIVATE_DEPS_LIBDIR} ${CACHED_UNITY_PRIVATE_DEPS_LIBRARY_DIRS})
set(UNITY_STANDALONE_LADD ${UNITY_STANDALONE_LADD} ${UNITY_PROTOCOL_PRIVATE_LIB})

add_subdirectory(a11y)
add_subdirectory(unity-shared)
add_subdirectory(dash)
add_subdirectory(launcher)
add_subdirectory(data)

if (ENABLE_X_SUPPORT)
  add_subdirectory(hud)
  add_subdirectory(lockscreen)
  add_subdirectory(panel)
  add_subdirectory(decorations)
  add_subdirectory(plugins/unityshell)
  add_subdirectory(plugins/unity-mt-grab-handles)
  add_subdirectory(shortcuts)
  add_subdirectory(shutdown)
  add_subdirectory(unity-standalone)

  if (ENABLE_NETWORKAREAREGION_PLUGIN)
    add_subdirectory(plugins/networkarearegion)
  endif (ENABLE_NETWORKAREAREGION_PLUGIN)

endif ()

add_subdirectory(doc)
add_subdirectory(services)
add_subdirectory(tools)
add_subdirectory(UnityCore)
add_subdirectory(guides)
add_subdirectory(gnome)

if (ENABLE_UNIT_TESTS)
  add_subdirectory(tests)
else (ENABLE_UNIT_TESTS)
  set (MISSING_TESTS_MSG "-- Tests disabled, compile with -DENABLE_UNIT_TESTS=ON")
  add_custom_target (check COMMAND echo ${MISSING_TESTS_MSG})
  add_custom_target (check-headless COMMAND echo ${MISSING_TESTS_MSG})
  add_custom_target (gcheck COMMAND echo ${MISSING_TESTS_MSG})
endif (ENABLE_UNIT_TESTS)

# Resources
install (FILES resources/dash-widgets.json DESTINATION ${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}/themes)
file (GLOB _datafiles "${CMAKE_CURRENT_SOURCE_DIR}/resources/*")
install (FILES ${_datafiles} DESTINATION ${PKGDATADIR})

#
# docs
#

# check if doxygen is even installed
find_package(Doxygen)
if (DOXYGEN_FOUND STREQUAL "NO")
  message("Doxygen not found. Documentation will not be built")
endif (DOXYGEN_FOUND STREQUAL "NO")

if (DOXYGEN_FOUND STREQUAL "YES")
  set(TOP_SRCDIR ${CMAKE_CURRENT_SOURCE_DIR})

  # prepare doxygen configuration file
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

  # add doxygen as target
  add_custom_target(doxygen ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

  # cleanup $build/api-doc on "make clean"
  set_property(DIRECTORY APPEND PROPERTY
         ADDITIONAL_MAKE_CLEAN_FILES api-doc)

endif (DOXYGEN_FOUND STREQUAL "YES")

=== data/CMakeLists.txt ===
add_subdirectory(compiz)
add_subdirectory(pam)

# GSettings Schema
SET (UNITY_SCHEMAS "com.canonical.Unity.gschema.xml")
SET (UNITY_TEST_SCHEMAS "external.gschema.xml")

# Have an option to not install the schema into where GLib is
option (GSETTINGS_LOCALINSTALL "Install GSettings Schemas locally instead of to the GLib prefix" OFF)
if (GSETTINGS_LOCALINSTALL)
    SET (GSETTINGS_DIR "${CMAKE_INSTALL_DATADIR}/glib-2.0/schemas/")
else (GSETTINGS_LOCALINSTALL)
    execute_process (COMMAND ${PKG_CONFIG_EXECUTABLE} glib-2.0 --variable prefix  OUTPUT_VARIABLE _glib_prefix OUTPUT_STRIP_TRAILING_WHITESPACE)
    SET (GSETTINGS_DIR "${_glib_prefix}/share/glib-2.0/schemas/")
endif (GSETTINGS_LOCALINSTALL)

# Run the validator and error if it fails
execute_process (COMMAND ${PKG_CONFIG_EXECUTABLE} gio-2.0 --variable glib_compile_schemas  OUTPUT_VARIABLE _glib_comple_schemas OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process (COMMAND ${_glib_comple_schemas} --dry-run --schema-file=${CMAKE_CURRENT_SOURCE_DIR}/${UNITY_SCHEMAS} ERROR_VARIABLE _schemas_invalid OUTPUT_STRIP_TRAILING_WHITESPACE)

if (_schemas_invalid)
  message (SEND_ERROR "Schema validation error: ${_schemas_invalid}")
endif (_schemas_invalid)

# Actually install and recomple schemas
message (STATUS "GSettings schemas will be installed into ${GSETTINGS_DIR}")
install (FILES ${UNITY_SCHEMAS} DESTINATION ${GSETTINGS_DIR} OPTIONAL)
install (CODE "message (STATUS \"Compiling GSettings schemas\")")
install (CODE "execute_process (COMMAND ${_glib_comple_schemas} ${GSETTINGS_DIR})")

# Settings for testing
configure_file (${CMAKE_SOURCE_DIR}/data/${UNITY_SCHEMAS} ${CMAKE_BINARY_DIR}/settings/${UNITY_SCHEMAS})
configure_file (${CMAKE_SOURCE_DIR}/tests/data/${UNITY_TEST_SCHEMAS} ${CMAKE_BINARY_DIR}/settings/${UNITY_TEST_SCHEMAS})
execute_process (COMMAND ${_glib_comple_schemas} ${CMAKE_BINARY_DIR}/settings)

# Upstart
configure_file(unity7.conf.in ${CMAKE_CURRENT_BINARY_DIR}/unity7.conf @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/unity7.conf DESTINATION ${CMAKE_INSTALL_DATADIR}/upstart/sessions)

# Systemd
configure_file(unity7.service.in ${CMAKE_CURRENT_BINARY_DIR}/unity7.service @ONLY)
pkg_get_variable(SYSTEMD_USER_DIR systemd systemduserunitdir)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/unity7.service DESTINATION ${SYSTEMD_USER_DIR})
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/unity7.override DESTINATION ${CMAKE_INSTALL_DATADIR}/upstart/systemd-session/upstart)

=== unity-shared/CMakeLists.txt ===
set(UNITY_SRC ../plugins/unityshell/src)

set (CFLAGS
     ${CACHED_UNITY_DEPS_CFLAGS}
     ${CACHED_UNITY_DEPS_CFLAGS_OTHER}
     ${PIC_FLAGS}
     )

string (REPLACE ";" " " CFLAGS "${CFLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CFLAGS}")

set (LIBS ${CACHED_UNITY_DEPS_LDFLAGS} ${UNITY_STANDALONE_LADD})

include_directories (.. ../services ../UnityCore ${UNITY_SRC} ${CMAKE_BINARY_DIR})

#
# Headers & Sources
#
set (UNITY_SHARED_SOURCES
     ApplicationManager.cpp
     AppStreamApplication.cpp
     BGHash.cpp
     CoverArt.cpp
     BackgroundEffectHelper.cpp
     DashStyle.cpp
     DebugDBusInterface.cpp
     DecorationStyle.cpp
     DefaultThumbnailProvider.cpp
     DeltaRestrainment.cpp
     DesktopApplicationManager.cpp
     EMConverter.cpp
     ExpanderView.cpp
     GnomeFileManager.cpp
     FontSettings.cpp
     GraphicsUtils.cpp
     IMTextEntry.cpp
     IconLoader.cpp
     IconRenderer.cpp
     IconTexture.cpp
     IconTextureSource.cpp
     Introspectable.cpp
     IntrospectableWrappers.cpp
     IntrospectionData.cpp
     JSONParser.cpp
     LayoutSystem.cpp
     LineSeparator.cpp
     MenuManager.cpp
     OverlayRenderer.cpp
     OverlayScrollView.cpp
     OverlayWindowButtons.cpp
     PanelStyle.cpp
     PlacesVScrollBar.cpp
     PlacesOverlayVScrollBar.cpp
     PreviewStyle.cpp
     RatingsButton.cpp
     RawPixel.cpp
     ResizingBaseWindow.cpp
     SearchBar.cpp
     SearchBarSpinner.cpp
     SpreadFilter.cpp
     SpreadWidgets.cpp
     StaticCairoText.cpp
     SystemdWrapper.cpp
     TextureCache.cpp
     TextInput.cpp
     TextureThumbnailProvider.cpp
     ThemeSettings.cpp
     ThumbnailGenerator.cpp
     Timer.cpp
     UBusServer.cpp
     UBusWrapper.cpp
     UScreen.cpp
     UnitySettings.cpp
     UnityWindowStyle.cpp
     UnityWindowView.cpp
     UpstartWrapper.cpp
     UserThumbnailProvider.cpp
     WindowButtons.cpp
     WindowManager.cpp
)

if(ENABLE_X_SUPPORT)
  set (UNITY_SHARED_SOURCES
    XKeyboardUtil.cpp
    XWindowManager.cpp
    InputMonitor.cpp
    ${UNITY_SHARED_SOURCES}
    )
else()
  set (UNITY_SHARED_SOURCES
    FakeKeyboardUtil.cpp
    ${UNITY_SHARED_SOURCES}
    )
endif()

add_library (unity-shared STATIC ${UNITY_SHARED_SOURCES})
target_link_libraries (unity-shared ${LIBS})
add_dependencies (unity-shared unity-core-${UNITY_API_VERSION})
add_pch(pch/unity-shared_pch.hh unity-shared)

#
# We also need to build compiz specific parts and standalone variants of those parts
#

if (ENABLE_X_SUPPORT)
  # compiz

  set (UNITY_SHARED_COMPIZ_SOURCES
    CompizUtils.cpp
    PluginAdapter.cpp
    GnomeKeyGrabber.cpp
    )

  find_package (PkgConfig)
  pkg_check_modules (COMPIZ REQUIRED compiz)
  pkg_check_modules (COMPIZ_OPENGL REQUIRED compiz-opengl)

  add_library (unity-shared-compiz STATIC ${UNITY_SHARED_COMPIZ_SOURCES})

  # This makes linker to include library dir in RUNPATH
  find_library (COMPIZ_LIB compiz_core ${COMPIZ_LIBDIR})
  find_library (COMPIZ_OPENGL_LIB opengl ${COMPIZ_OPENGL_LIBDIR})
  target_link_libraries (unity-shared-compiz
                         ${LIBS}
                         ${COMPIZ_LIB}
                         ${COMPIZ_LDFLAGS}
                         ${COMPIZ_OPENGL_LIB}
                         ${COMPIZ_OPENGL_LDFLAGS})
  add_dependencies (unity-shared-compiz unity-shared)

  # bamf application manager
  set (UNITY_SHARED_BAMF_SOURCES
    DesktopApplicationManager.cpp
    BamfApplicationManager.cpp
    BamfApplicationManagerFactory.cpp
    )
  add_library (unity-shared-bamf STATIC ${UNITY_SHARED_BAMF_SOURCES})
  target_link_libraries (unity-shared-bamf ${LIBS})
  add_dependencies (unity-shared-bamf unity-shared)
endif()

# standalone
set (UNITY_SHARED_STANDALONE_SOURCES
     StandaloneWindowManager.cpp
     )
add_library (unity-shared-standalone STATIC ${UNITY_SHARED_STANDALONE_SOURCES})
target_link_libraries (unity-shared-standalone ${LIBS})
add_dependencies (unity-shared-standalone unity-shared)

add_executable (app-manager StandaloneAppManager.cpp)
add_dependencies (app-manager  unity-shared unity-shared-bamf unity-shared-standalone)
target_link_libraries (app-manager  unity-shared unity-shared-bamf  unity-shared-standalone)

add_executable (decorations-style StandaloneDecorationStyle.cpp)
add_dependencies (decorations-style unity-shared)
target_link_libraries (decorations-style unity-shared)

=== data/compiz/CMakeLists.txt ===
find_package (PkgConfig REQUIRED)

pkg_check_modules (COMPIZCONFIG libcompizconfig)

if (COMPIZCONFIG_FOUND)
    pkg_get_variable (COMPIZCONFIG_CONFIG_DIR libcompizconfig configdir)
    pkg_get_variable (COMPIZCONFIG_UPGRADES_DIR libcompizconfig upgradesdir)

    set (config_files
         unity.conf
         unity.ini
         unity-lowgfx.ini)

    set (upgrade_files
         upgrades/com.canonical.unity.unity.01.upgrade
         upgrades/com.canonical.unity.unity.02.upgrade
         upgrades/com.canonical.unity.unity.03.upgrade
         upgrades/com.canonical.unity.unity.04.upgrade
         upgrades/com.canonical.unity.unity.05.upgrade
         upgrades/com.canonical.unity.unity.06.upgrade
         upgrades/com.canonical.unity.unity.07.upgrade
         upgrades/com.canonical.unity.unity-lowgfx.01.upgrade)

    install (FILES ${config_files} DESTINATION ${COMPIZCONFIG_CONFIG_DIR})
    install (FILES ${upgrade_files} DESTINATION ${COMPIZCONFIG_UPGRADES_DIR})
endif ()

=== plugins/networkarearegion/CMakeLists.txt ===
find_package (Compiz REQUIRED)

include (CompizPlugin)

# Guard against Compiz altering global state.
# https://bugs.launchpad.net/compiz/+bug/1096807
if(CMAKE_BUILD_TYPE STREQUAL "")
  set(revert_compiz TRUE)
endif()

set (libdir ${CMAKE_INSTALL_LIBDIR})
set (includedir ${CMAKE_INSTALL_INCLUDEDIR})
set (libdir ${CMAKE_INSTALL_LIBDIR})
set (datadir ${CMAKE_INSTALL_FULL_DATADIR})

compiz_plugin (networkarearegion)

if(revert_compiz)
  set (CMAKE_BUILD_TYPE "" CACHE STRING "Build type (Debug/Release/RelWithDebInfo/MinSizeRe)" FORCE)
endif()

=== tests/test-minimize-window-handler/CMakeLists.txt ===
project (test-input-remover)

pkg_check_modules (COMPIZ_TEST_MINIMIZED_HANDER REQUIRED x11 xext)

if (COMPIZ_TEST_MINIMIZED_HANDER_FOUND)
	include_directories (${COMPIZ_TEST_MINIMIZED_HANDER_INCLUDE_DIRS}
			     ..
			     ../../plugins/unityshell/src)

	link_directories (${COMPIZ_TEST_MINIMIZED_HANDER_LINK_DIRS})

	add_executable (test-minimize-handler
			test-minimize-handler.cpp
			../../plugins/unityshell/src/minimizedwindowhandler.cpp
			../x11-window.cpp
			../x11-window-read-transients.cpp
			../../plugins/unityshell/src/transientfor.cpp
			../../plugins/unityshell/src/inputremover.cpp)
        add_dependencies (test-minimize-handler unity-core-${UNITY_API_VERSION})
	target_link_libraries (test-minimize-handler
			       ${COMPIZ_TEST_MINIMIZED_HANDER_LIBRARIES})

endif (COMPIZ_TEST_MINIMIZED_HANDER_FOUND)

=== debian/changelog ===
unity (7.5.1+22.04.20211026.2-0ubuntu1) jammy; urgency=medium

  [ Uladzislau Nikalayevich ]
  * DecoratedWindow: Do not try to use shaped shadows on empty quads.
    Windows may have no shaped rectangles, but we're still trying to set
    them. This is because we might not initialize the shape size, leading
    to invalid values. (LP: #1904337)

  [ Marco Trevisan (Treviño) ]
  * DecorationsShape: Initialize parameters on missing rectangles.
    In such case the shape should just be empty, but we didn't really handle
    the case properly.
  * dummy-xorg-test-runner: Use command -v instead of deprecated which
  * TestSwitchController: Do not define FakeApplicationWindow as NiceMock twice.
    It's already used as ::Nice later, no need to define it initially,
    otherwise newer gtest won't compile

 -- Marco Trevisan (Treviño) <mail@3v1n0.net>  Tue, 26 Oct 2021 17:36:55 +0000

=== debian/control ===
Source: unity
Section: gnome
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: cmake,
               compiz-dev (>= 1:0.9.13.1+18.04.20180221),
               debhelper (>= 9.0.0~),
               dbus-test-runner,
               dbus-x11,
               dh-migrations,
               dh-translations (>= 94),
               dh-python,
               google-mock (>= 1.6.0+svn437),
               gsettings-desktop-schemas-dev,
               gsettings-ubuntu-schemas (>= 0.0.7+17.10.20170922),
               intltool (>= 0.35.0),
               libappstream-glib-dev,
               libatk1.0-dev,
               libbamf3-dev (>= 0.5.3~bzr0),
               libboost-dev,
               libcairo2-dev,
               libcompizconfig0-dev (>= 1:0.9.13.1+19.04.20190208-0ubuntu1),
               libdbus-1-dev,
               libdbusmenu-glib-dev (>= 0.3.91),
               libdee-dev (>= 1.2.6),
               libgeis-dev (>= 2.0.10),
               libgl1-mesa-dri,
               libglib2.0-dev (>= 2.39.1),
               libgnome-desktop-3-dev,
               libunity-settings-daemon-dev,
               unity-settings-daemon-dev (>= 15.04.1+19.10.20190921-0ubuntu3),
               libgtest-dev,
               libgtk-3-dev (>= 3.1),
               libido3-0.1-dev (>= 13.10.0),
               libindicator-dev (>= 0.12.2),
               libindicator3-dev (>= 0.12.2),
               libjson-glib-dev,
               libjson-perl,
               libnotify-dev,
               libnux-4.0-dev (>= 4.0.6),
               libpam0g-dev,
               libpango1.0-dev,
               libsigc++-2.0-dev (>= 2.4.0),
               libstartup-notification0-dev,
               libunique-dev,
               libunity-dev (>= 7.1.0),
               libunity-misc-dev (>= 4.0.4),
               libxcb-icccm4-dev,
               libxfixes-dev (>= 1:5.0.1),
               libxi-dev (>= 2:1.7.1.901),
               libxpathselect-dev (>=1.4),
               libxtst-dev,
               libzeitgeist-2.0-dev,
               pkg-config,
               python3-all (>= 3.4),
               python3-setuptools,
               quilt,
               systemd,
               xserver-xorg-video-dummy,
               xsltproc,
               yaru-theme-icon,
Standards-Version: 3.9.5
Homepage: https://launchpad.net/unity
# If you aren't a member of ~unity-team but need to upload packaging changes,
# just go ahead.  ~unity-team will notice and sync up the code again.
Vcs-Bzr: https://code.launchpad.net/~unity-team/unity/trunk
X-Ubuntu-Use-Langpack: yes

Package: unity
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends},
         libunity-core-6.0-9 (= ${binary:Version}),
         compiz,
         compiz-core, compiz-core-abiversion-${coreabiversion},
         libnux-abiversion-${nuxabiversion},
         compiz-plugins-default,
         gsettings-ubuntu-schemas (>= 0.0.7+17.10.20170922),
         unity-settings-daemon-schemas (>= 15.04.1+19.10.20190921-0ubuntu3),
         libglib2.0-bin,
         nux-tools,
         python3-gi,
         dconf-cli,
         unity-asset-pool (>= 0.8.18),
         unity-greeter,
         bamfdaemon,
         libxfixes3 (>= 1:5.0.1-1),
         libxi6 (>= 2:1.7.1.901),
	 unity-scope-home,
Recommends: unity-control-center,
            ${unity-default-masterscopes}
            nautilus (>> 3.37.1),
            nemo,
            gnome-disk-utility,
            hud,
            session-shortcuts,
            unity-session,
Breaks: unity-lens-applications (<< 5.12.0-0ubuntu2),
        unity-lens-files (<< 5.10.0-0ubuntu2),
        unity-lens-music (<< 6.0.0),
        unity-lens-video (<< 0.3.6-0ubuntu2),
        ubuntu-session (<< 3.24.1-0ubuntu3~),
        compiz-gnome (<< 1:0.9.13.1+19.04.20190208-0ubuntu1~),
Replaces: compiz-gnome (<< 1:0.9.13.1+19.04.20190208-0ubuntu1~),
Description: Interface designed for efficiency of space and interaction.
 Unity is a desktop experience that sings. Designed by Canonical and the Ayatana
 community, Unity is all about the combination of familiarity and the future. We
 bring together visual design, analysis of user experience testing, modern
 graphics technologies and a deep understanding of the free software landscape
 to produce what we hope will be the lightest, most elegant and most delightful
 way to use your PC.

Package: unity-services
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         indicator-common,
Provides: indicator-renderer
Recommends: indicator-appmenu (>= 15.02.0),
            indicator-application,
            indicator-sound,
            indicator-bluetooth,
            indicator-datetime,
            indicator-keyboard,
            indicator-messages,
            indicator-printers,
            indicator-power,
            indicator-session,
Description: Services for the Unity interface
 Unity is a desktop experience that sings. Designed by Canonical and the Ayatana
 community, Unity is all about the combination of familiarity and the future. We
 bring together visual design, analysis of user experience testing, modern
 graphics technologies and a deep understanding of the free software landscape
 to produce what we hope will be the lightest, most elegant and most delightful
 way to use your PC.
 .
 This package contains the D-Bus service used for unity.

Package: unity-schemas
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Replaces: libunity-core-6.0-9 (<< 7.3.0),
Breaks: libunity-core-6.0-9 (<< 7.3.0),
Description: Interface designed for efficiency of space and interaction.
 Unity is a desktop experience that sings. Designed by Canonical and the Ayatana
 community, Unity is all about the combination of familiarity and the future. We
 bring together visual design, analysis of user experience testing, modern
 graphics technologies and a deep understanding of the free software landscape
 to produce what we hope will be the lightest, most elegant and most delightful
 way to use your PC.
 .
 This package contains the configuration schemas used by unity.

Package: libunity-core-6.0-9
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         unity-services (= ${binary:Version}),
         unity-schemas (= ${binary:Version}),
Conflicts: unity-common, libunity-core-6.0-6, libunity-core-6.0-7, libunity-core-6.0-8
Replaces: unity-common, libunity-core-6.0-6, libunity-core-6.0-7, libunity-core-6.0-8
Provides: unity-common, unity-common-7.0
Description: core library for the Unity interface
 Unity is a desktop experience that sings. Designed by Canonical and the Ayatana
 community, Unity is all about the combination of familiarity and the future. We
 bring together visual design, analysis of user experience testing, modern
 graphics technologies and a deep understanding of the free software landscape
 to produce what we hope will be the lightest, most elegant and most delightful
 way to use your PC.
 .
 This package contains shared libraries to be used by unity-3d.

Package: libunity-core-6.0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libunity-core-6.0-9 (= ${binary:Version}),
         libglib2.0-dev,
         libsigc++-2.0-dev,
         libnux-4.0-dev (>= 4.0.5),
         libunity-dev (>= 7.1.0~),
         libdee-dev,
Description: Core library for the Unity interface - development files
 Unity is a desktop experience that sings. Designed by Canonical and the Ayatana
 community, Unity is all about the combination of familiarity and the future. We
 bring together visual design, analysis of user experience testing, modern
 graphics technologies and a deep understanding of the free software landscape
 to produce what we hope will be the lightest, most elegant and most delightful
 way to use your PC.
 .
 This package contains development files for libraries to be used by unity.

Package: unity-autopilot
Section: python
Architecture: all
Depends: ${misc:Depends},
         ${python3:Depends},
         autopilot-desktop,
         gir1.2-appindicator3-0.1,
         gir1.2-dee-1.0,
         gir1.2-glib-2.0,
         gir1.2-ibus-1.0,
         gir1.2-unity-5.0,
         python3-compizconfig,
         python3-dbus,
         python3-testtools,
         python3-xdg,
         python3-xlib,
         libxpathselect1.4v5 (>= 1.4),
         mesa-utils,
Description: Autopiloted tests for Unity
 Unity is tested automatically through autopilot, a framework which enables
 keyboard and mouse events to be triggered on the fly as well as object
 introspection.  This package contains the specific unity introspection
 bindings to be able to write tests in python as well as the full test suite
 for Unity.

## unity 7.6.0+22.10.20220913-0ubuntu1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 project (unity)
-cmake_minimum_required(VERSION 2.8.9)
+cmake_minimum_required(VERSION 3.17.0)
 
 include (cmake/Documentation.cmake)
 include (cmake/pch.cmake)
@@ -10,8 +10,8 @@
 #
 set (PROJECT_NAME "unity")
 set (UNITY_MAJOR 7)
-set (UNITY_MINOR 5)
-set (UNITY_MICRO 1)
+set (UNITY_MINOR 6)
+set (UNITY_MICRO 0)
 set (UNITY_VERSION "${UNITY_MAJOR}.${UNITY_MINOR}.${UNITY_MICRO}")
 set (UNITY_API_VERSION "6.0")
 set (UNITY_COMPONENTS_VERSION "6")

=== unity-shared/CMakeLists.txt ===
--- 
+++ 
@@ -30,6 +30,7 @@
      DesktopApplicationManager.cpp
      EMConverter.cpp
      ExpanderView.cpp
+     FileManager.cpp
      GnomeFileManager.cpp
      FontSettings.cpp
      GraphicsUtils.cpp
@@ -45,6 +46,7 @@
      LayoutSystem.cpp
      LineSeparator.cpp
      MenuManager.cpp
+     NemoFileManager.cpp
      OverlayRenderer.cpp
      OverlayScrollView.cpp
      OverlayWindowButtons.cpp

=== debian/changelog ===
unity (7.6.0+22.10.20220913-0ubuntu1) kinetic; urgency=medium

  [ Rudra Saraswat ]
  * Added transparent dash border
  * Replaced launcher bfb with Ubuntu Unity logo
  * Removed broken app info and ratings from dash
  * Simplified app preview in dash
  * Fixed the 'Empty Trash' button in the launcher
  * Fixed the standalone testing Unity7 launcher

 -- Marco Trevisan (Treviño) <mail@3v1n0.net>  Tue, 13 Sep 2022 15:01:46 +0000

unity (7.5.1+22.10.20220818-0ubuntu1) kinetic; urgency=medium

  [ Alberts Muktupāvels ]
  * Fix build after Compiz changes

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Thu, 18 Aug 2022 10:35:27 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: gnome
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-Build-Depends: cmake,
+Build-Depends: cmake (>= 3.17.0),
                compiz-dev (>= 1:0.9.13.1+18.04.20180221),
                debhelper (>= 9.0.0~),
                dbus-test-runner,
@@ -90,7 +90,6 @@
 	 unity-scope-home,
 Recommends: unity-control-center,
             ${unity-default-masterscopes}
-            nautilus (>> 3.37.1),
             nemo,
             gnome-disk-utility,
             hud,

## unity 7.7.0%2B23.04.20230222.2-0ubuntu7

=== unity-shared/CMakeLists.txt ===
--- 
+++ 
@@ -30,9 +30,9 @@
      DesktopApplicationManager.cpp
      EMConverter.cpp
      ExpanderView.cpp
-     FileManager.cpp
      GnomeFileManager.cpp
      FontSettings.cpp
+     FileManager.cpp
      GraphicsUtils.cpp
      IMTextEntry.cpp
      IconLoader.cpp

## unity 7.7.0%2B23.04.20230222.2-0ubuntu8

=== shortcuts/CMakeLists.txt ===
set(UNITY_SRC ../plugins/unityshell/src)

set (CFLAGS
     ${CACHED_UNITY_DEPS_CFLAGS}
     ${CACHED_UNITY_DEPS_CFLAGS_OTHER}
     ${PIC_FLAGS}
     )

string (REPLACE ";" " " CFLAGS "${CFLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CFLAGS}")

set (LIBS ${CACHED_UNITY_DEPS_LDFLAGS} ${UNITY_STANDALONE_LADD})

include_directories (.. ../services ../UnityCore ${UNITY_SRC} ${CMAKE_BINARY_DIR})

#
# Headers & Sources
#
set (SHORTCUTS_SOURCES
     AbstractShortcutHint.h
     AbstractShortcutModeller.h
     BaseWindowRaiserImp.cpp
     CompizShortcutModeller.cpp
     MockShortcutHint.h
     ShortcutController.cpp
     ShortcutController.h
     ShortcutHint.cpp
     ShortcutHintPrivate.cpp
     ShortcutModel.cpp
     ShortcutModel.h
     ShortcutView.cpp
     ShortcutView.h
     )

add_library (shortcuts-lib STATIC ${SHORTCUTS_SOURCES})
add_dependencies (shortcuts-lib unity-core-${UNITY_API_VERSION} unity-shared)
add_pch(pch/shortcuts_pch.hh shortcuts-lib)

# 
# Standalone variant
#
add_executable (shortcuts StandaloneShortcuts.cpp)
target_link_libraries (shortcuts shortcuts-lib unity-shared unity-shared-standalone)

## unity 7.7.0+23.04.20230222.2-0ubuntu2

=== debian/changelog ===
unity (7.7.0+23.04.20230222.2-0ubuntu2) lunar; urgency=medium

  [ Rudra Saraswat ]
  * Remove indicator-messages due to crashes, add indicator-notifications

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Tue, 18 Apr 2023 21:41:06 +0300

unity (7.7.0+23.04.20230222.2-0ubuntu1) lunar; urgency=medium

  [ Rudra Saraswat ]
  * Added UWidgets, a new widget system for Unity based on Blighty
  * Made the dash vertical and moved the scope bar to the top
  * Increased the panel height to 30
  * Added indicator-notifications as a Recommend

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Wed, 22 Feb 2023 18:38:29 +0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_TYPE := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
gles2_architectures := armel armhf
ignore_warnings_archs := armhf ppc64el s390x

DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')

# http://ccache.samba.org/manual.html#_precompiled_headers
CCACHE_SLOPPINESS=time_macros

CORE_ABIVERSION := $(shell sed -rn 's/^\#define[[:space:]]+CORE_ABIVERSION[[:space:]]+//p' /usr/include/compiz/core/abiversion.h )
NUX_ABIVERSION := $(shell sed -rn 's/^\#define[[:space:]]+NUX_ABIVERSION[[:space:]]+//p' /usr/include/Nux-4.0/Nux/ABI.h )
LIBUNITY_PRIVATE := $(shell pkg-config --libs-only-L unity-protocol-private | sed -e 's/-L\(.*\)/\1/' )
SCOPES_RECOMMENDS := $(shell perl debian/scopes-recommends-generator /usr/share/unity/client-scopes.json)

cmake_options := -DCOMPIZ_BUILD_WITH_RPATH=FALSE \
                 -DCOMPIZ_PACKAGING_ENABLED=TRUE \
                 -DCOMPIZ_PLUGIN_INSTALL_TYPE=package

ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(gles2_architectures)))
  cmake_options += -DBUILD_GLES=TRUE -DDISABLE_MAINTAINER_CXXFLAGS=ON
endif

ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(ignore_warnings_archs)))
  cmake_options += -DDISABLE_MAINTAINER_CXXFLAGS=ON
endif

override_dh_auto_configure:
	dh_auto_configure -- $(cmake_options)

override_dh_install:
	# install autopilot tests
	cd tests/autopilot; python3 setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb;
	find debian/tmp/usr/lib -name \*.*a -exec rm {} \;
	rm -rf debian/tmp/usr/share/gconf/schemas
	# install uwidgets
	cd uwidgets; python3 setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb
	install -Dm755 uwidgets/uwidgets-runner.desktop $(CURDIR)/debian/tmp/etc/xdg/autostart/uwidgets-runner.desktop
	dh_install --fail-missing

override_dh_gencontrol:
	dh_gencontrol -- -Vcoreabiversion=$(CORE_ABIVERSION) -Vnuxabiversion=$(NUX_ABIVERSION) -Vunity-default-masterscopes="$(SCOPES_RECOMMENDS)"

override_dh_makeshlibs:
	dh_makeshlibs -plibunity-core-6.0-9 -V 'libunity-core-6.0-9 (>= 7.0.0)'

override_dh_shlibdeps:
	dh_shlibdeps -l$(LIBUNITY_PRIVATE) -O--parallel

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make -C obj-$(DEB_HOST_GNU_TYPE) check-headless
endif

%:
	dh $@ --with translations,quilt,python3,migrations --parallel
